#info Notice: set Render mode to Continous
#info Theli-at's Pseudo Kleinian (Scale 1 JuliaBox + Something
//#define providesInit
#define USE_IQ_CLOUDS
#define KN_VOLUMETRIC
#define USE_EIFFIE_SHADOW
#define MULTI_SAMPLE_AO
#define AUTOFOCUS
#include "colorpalette.frag"
#include "DE-Kn2cr11.frag"
#include "MathUtils.frag"
#group PseudoKleinian

#define USE_INF_NORM

// Made by Knighty, see this thread:
// http://www.fractalforums.com/3d-fractal-generation/fragmentarium-an-ide-for-exploring-3d-fractals-and-other-systems-on-the-gpu/msg32270/#msg32270


uniform int MI; slider[0,5,20]
uniform int ColorIterations;  slider[0,3,300]
//uniform float Bailout; slider[0,20,1000]
uniform float Size; slider[0,1,2]
uniform vec3 CSize; slider[(0,0,0),(1,1,1),(2,2,2)]
uniform vec3 C; slider[(-2,-2,-2),(0,0,0),(2,2,2)]
uniform float TThickness; slider[0,0.01,2]
uniform float DEoffset; slider[0,0,0.01]
uniform vec3 Offset; slider[(-1,-1,-1),(0,0,0),(1,1,1)]

float RoundBox(vec3 p, vec3 csize, float offset)
{
	vec3 di = abs(p) - csize;
	float k=max(di.x,max(di.y,di.z));
	return abs(k*float(k<0.)+ length(max(di,0.0))-offset);
}

float Thingy(vec3 p, float e){
	p-=Offset;
	return (abs(length(p.xy)*p.z)-e) / sqrt(dot(p,p)+abs(e));
}

float Thing2(vec3 p){
//Just scale=1 Julia box
	float DEfactor=1.;
   	vec3 ap=p+1.;
	for(int i=0;i<MI && ap!=p;i++){
		ap=p;
		p=2.*clamp(p, -CSize, CSize)-p;
      
		float r2=dot(p,p);
		orbitTrap = min(orbitTrap, abs(vec4(p,r2)));
		float k=max(Size/r2,1.);

		p*=k;DEfactor*=k;
      
		p+=C;
		orbitTrap = min(orbitTrap, abs(vec4(p,dot(p,p))));
	}
	//Call basic shape and scale its DE
	//return abs(0.5*Thingy(p,TThickness)/DEfactor-DEoffset);
	
	//Alternative shape
	//return abs(0.5*RoundBox(p, vec3(1.,1.,1.), 1.0)/DEfactor-DEoffset);
	//Just a plane
	return abs(0.5*abs(p.z-Offset.z)/DEfactor-DEoffset);
}


float Coloring(vec3 p){
	float expsmooth=0.0;
	float r1 = 0.0, r2 = 0.0;
//Just scale=1 Julia box
	float DEfactor=1.;
   	vec3 ap=p+1.;
	for(int i=0;i<ColorIterations && ap!=p;i++){
		ap=p;
		p=2.*clamp(p, -CSize, CSize)-p;
      
		float r2=dot(p,p);
		orbitTrap = min(orbitTrap, abs(vec4(p,r2)));
		float k=max(Size/r2,1.);

		p*=k;DEfactor*=k;
      
		p+=C;
		orbitTrap = min(orbitTrap, abs(vec4(p,dot(p,p))));
	
	//Call basic shape and scale its DE
	//return abs(0.5*Thingy(p,TThickness)/DEfactor-DEoffset);
	
	//Alternative shape
	//return abs(0.5*RoundBox(p, vec3(1.,1.,1.), 1.0)/DEfactor-DEoffset);
	//Just a plane
		expsmooth+=exp(-1.0/abs(r1-r2));	
	}
	return expsmooth;
}

float DE(vec3 p){
	return  Thing2(p);//RoundBox(p, CSize, Offset);
}





#preset Default
Color1 = 0,1,1
Color2 = 0.7529412,0.4980392,0.08627451
Color3 = 1,0,0
ColorDensity = 0.1950673
ColorOffset = 0.7778609
AutoFocus = false
FOV = 0.54166
Eye = 0.7071131,2.859794,1.949757
Target = 7.898422,9.793154,0.1154124
UpLock = false
Up = 0.1423541,0.1125171,0.983367
AutoFocus = false
FocalPlane = 0.6499322
Aperture = 0.0122
InFocusAWidth = 0.1448171
DofCorrect = true
ApertureNbrSides = 7
ApertureRot = 0
ApStarShaped = false
Gamma = 2.08335
ToneMapping = 3
Exposure = 1.19388
Brightness = 1
Contrast = 1
Saturation = 1
GaussianWeight = 1
AntiAliasScale = 1
Bloom = true
BloomIntensity = 0
BloomPow = 2
BloomTaps = 4
BloomStrong = 1
DepthToAlpha = false
Detail = -3.282866
RefineSteps = 4
FudgeFactor = 0.641994
MaxRaySteps = 376
MaxDistance = 550
Dither = 0.39474
NormalBackStep = 1
DetailAO = -0.5
coneApertureAO = 0.5
maxIterAO = 93
FudgeAO = 0.7599705
AO_ambient = 1.855148
AO_camlight = 1.687827
AO_pointlight = 1.878561
AoCorrect = 0.9823875
Specular = 0.2857143
SpecularExp = 16
CamLight = 1,0.9490196,0.7529412,0.3809524
AmbiantLight = 1,0.9529412,0.8431373,1.547893
Reflection = 0.7215686,0.6784314,0.5137255
ReflectionsNumber = 1
SpotGlow = true
SpotLight = 1,0.9803922,0.7215686,5.115207
LightPos = 1.63769,3.39298,1.220974
LightSize = 0.1839166
LightFallOff = 0.1699248
LightGlowRad = 0.3484848
LightGlowExp = 2.573203
HardShadow = 0
ShadowSoft = 2
ShadowBlur = 0.0128297
perf = false
SSS = false
sss1 = 0.1
sss2 = 0.5
BaseColor = 1,0.9490196,0.7921569
OrbitStrength = 1
X = 0.5,0.6,0.6,1
Y = 1,0.6,0,0.78948
Z = 0.8,0.78,1,0.5
R = 1,0.666667,0,0.81334
BackgroundColor = 0.5490196,0.5921569,0.6313725
GradientBackground = 0
CycleColors = true
Cycles = 10.29
EnableFloor = false
FloorNormal = 0,0,0
FloorHeight = 0
FloorColor = 1,1,1
HF_Fallof = 0.4535079
HF_Const = 0.0603147
HF_Intensity = 0.0949535
HF_Dir = 0,0.8372294,-0.0961039
HF_Offset = -4.067924
HF_Color = 0.6039216,0.6862745,0.8745098,2.294118
HF_Scatter = 0.9962264
HF_Anisotropy = 0.9529412,0.9490196,0.9490196
HF_FogIter = 2
HF_CastShadow = true
EnCloudsDir = true NotLocked
Clouds_Dir = 0,0,1 NotLocked
CloudScale = 1 NotLocked
CloudFlatness = 0 NotLocked
CloudTops = 1 NotLocked
CloudBase = -1 NotLocked
CloudDensity = 1 NotLocked
CloudRoughness = 1 NotLocked
CloudContrast = 1 NotLocked
CloudColor = 0.65,0.68,0.7 NotLocked
CloudColor2 = 0.07,0.17,0.24 NotLocked
SunLightColor = 0.7,0.5,0.3 NotLocked
Cloudvar1 = 0.99 NotLocked
Cloudvar2 = 1 NotLocked
CloudIter = 5 NotLocked
CloudBgMix = 1 NotLocked
MI = 10
ColorIterations = 10
Size = 1.14664
CSize = 0.91112,1.08888,0.93334
C = 0.28572,0.3238,-0.05716
TThickness = 0.01
DEoffset = 0
Offset = 0.88888,0.4568,0.03704
#endpreset



#preset light2
Color1 = 0,1,1
Color2 = 0.7529412,0.4980392,0.08627451
Color3 = 1,0,0
ColorDensity = 0.0710015
ColorOffset = 0.4263276
AutoFocus = false
FOV = 0.54166
Eye = 0.7071131,2.859794,1.949757
Target = 7.898422,9.793154,0.1154124
UpLock = false
Up = 0.1423541,0.1125171,0.983367
AutoFocus = false
FocalPlane = 0.6499322
Aperture = 0.0122
InFocusAWidth = 0.1448171
DofCorrect = true
ApertureNbrSides = 7
ApertureRot = 0
ApStarShaped = false
Gamma = 2.08335
ToneMapping = 3
Exposure = 1.19388
Brightness = 1
Contrast = 1
Saturation = 1
GaussianWeight = 1
AntiAliasScale = 1
Bloom = true
BloomIntensity = 0
BloomPow = 2
BloomTaps = 4
BloomStrong = 1
DepthToAlpha = false
Detail = -3.282866
RefineSteps = 4
FudgeFactor = 0.641994
MaxRaySteps = 376
MaxDistance = 550
Dither = 0.39474
NormalBackStep = 1
DetailAO = -0.5
coneApertureAO = 0.5
maxIterAO = 93
FudgeAO = 0.7599705
AO_ambient = 1.855148
AO_camlight = 1.896938
AO_pointlight = 1.878561
AoCorrect = 0.9823875
Specular = 0.1030928
SpecularExp = 16
CamLight = 1,0.9490196,0.7529412,1.475435
AmbiantLight = 1,0.9529412,0.8431373,1.463601
Reflection = 0.7215686,0.6784314,0.5137255
ReflectionsNumber = 1
SpotGlow = true
SpotLight = 1,0.9803922,0.7215686,1.935484
LightPos = 1.63769,3.39298,1.220974
LightSize = 0.1839166
LightFallOff = 0.1699248
LightGlowRad = 0.3333333
LightGlowExp = 2.573203
HardShadow = 0
ShadowSoft = 2
ShadowBlur = 0.0128297
perf = false
SSS = false
sss1 = 0.1
sss2 = 0.5
BaseColor = 1,0.9490196,0.7921569
OrbitStrength = 1
X = 0.5,0.6,0.6,1
Y = 1,0.6,0,0.78948
Z = 0.8,0.78,1,0.5
R = 1,0.666667,0,0.81334
BackgroundColor = 0.5490196,0.5921569,0.6313725
GradientBackground = 0
CycleColors = true
Cycles = 10.29
EnableFloor = false
FloorNormal = 0,0,0
FloorHeight = 0
FloorColor = 1,1,1
HF_Fallof = 0.4535079
HF_Const = 0
HF_Intensity = 0
HF_Dir = 0,0.8372294,-0.0961039
HF_Offset = -1.788679
HF_Color = 0.6039216,0.6862745,0.8745098,2.294118
HF_Scatter = 0.9962564
HF_Anisotropy = 0.9529412,0.9490196,0.9490196
HF_FogIter = 2
HF_CastShadow = true
EnCloudsDir = true NotLocked
Clouds_Dir = 0,0,1 NotLocked
CloudScale = 1 NotLocked
CloudFlatness = 0 NotLocked
CloudTops = 1 NotLocked
CloudBase = -1 NotLocked
CloudDensity = 1 NotLocked
CloudRoughness = 1 NotLocked
CloudContrast = 1 NotLocked
CloudColor = 0.65,0.68,0.7 NotLocked
CloudColor2 = 0.07,0.17,0.24 NotLocked
SunLightColor = 0.7,0.5,0.3 NotLocked
Cloudvar1 = 0.99 NotLocked
Cloudvar2 = 1 NotLocked
CloudIter = 5 NotLocked
CloudBgMix = 1 NotLocked
MI = 10
ColorIterations = 10
Size = 1.14664
CSize = 0.91112,1.08888,0.93334
C = 0.28572,0.3238,-0.05716
TThickness = 0.01
DEoffset = 0
Offset = 0.88888,0.4568,0.03704
#endpreset


#preset temp
Color1 = 0,1,1
Color2 = 0.7529412,0.4980392,0.08627451
Color3 = 1,0,0
ColorDensity = 0.1913303
ColorOffset = 1.346298
AutoFocus = true
FOV = 0.7933656
Eye = -8.094906,6.591293,18.25076
Target = -13.18987,3.228642,15.03369
UpLock = false
Up = -0.1292779,-0.1379605,0.3489456
AutoFocus = false
FocalPlane = 1.048474
Aperture = 0
InFocusAWidth = 0.9386724
DofCorrect = true
ApertureNbrSides = 7
ApertureRot = 0
ApStarShaped = false
Gamma = 0.4196051
ToneMapping = 5
Exposure = 1
Brightness = 1
Contrast = 1
Saturation = 1
GaussianWeight = 1
AntiAliasScale = 1.5
Bloom = true
BloomIntensity = 1.104197
BloomPow = 1.436741
BloomTaps = 18
BloomStrong = 4.328767
DepthToAlpha = false
Detail = -2.750369
RefineSteps = 4
FudgeFactor = 1
MaxRaySteps = 459
MaxDistance = 500
Dither = 0.75
NormalBackStep = 1
DetailAO = -0.6650246
coneApertureAO = 0.5
maxIterAO = 20
FudgeAO = 1
AO_ambient = 1.03267
AO_camlight = 1.142857
AO_pointlight = 1.559201
AoCorrect = 0.9866008
Specular = 0.1262272
SpecularExp = 19
CamLight = 0.345098,0.345098,0.345098,0.0695389
AmbiantLight = 1,0.9529412,0.8666667,0.8720307
Reflection = 0.5647059,0.5647059,0.5647059
ReflectionsNumber = 1
SpotGlow = true
SpotLight = 0.972549,0.9647059,0.8705882,0.7883212
LightPos = 1.004989,1.09052,1.119031
LightSize = 0.1573352
LightFallOff = 0.0958512
LightGlowRad = 0.1188761
LightGlowExp = 0.1691865
HardShadow = 1
ShadowSoft = 0
ShadowBlur = 0.0128297
perf = false
SSS = true
sss1 = 0.1
sss2 = 0.5
BaseColor = 1,0.9882353,0.9490196
OrbitStrength = 0.681656
X = 0.9098039,0.5254902,0.8588235,-0.6715789
Y = 0.5294118,0.7254902,0.9686275,-0.4905263
Z = 1,0.8980392,0.5215686,-0.7291228
R = 0.9921569,0.854902,0.7647059,-0.8272472
BackgroundColor = 0.6901961,0.9098039,1
GradientBackground = 3.572993
CycleColors = true
Cycles = 17.59608
EnableFloor = false
FloorNormal = 0,0,0
FloorHeight = 0
FloorColor = 1,1,1
HF_Fallof = 0.1
HF_Const = 0.0627803
HF_Intensity = 0.0506425
HF_Dir = 0,0,1
HF_Offset = 0.8742004
HF_Color = 0.5843137,0.9254902,0.9411765,0.8899214
HF_Scatter = 0
HF_Anisotropy = 0.3647059,0.3647059,0.3647059
HF_FogIter = 1
HF_CastShadow = false
EnCloudsDir = false NotLocked
Clouds_Dir = 0,0,1 NotLocked
CloudScale = 1 NotLocked
CloudFlatness = 0 NotLocked
CloudTops = 1 NotLocked
CloudBase = -1 NotLocked
CloudDensity = 1 NotLocked
CloudRoughness = 1 NotLocked
CloudContrast = 1 NotLocked
CloudColor = 0.65,0.68,0.7 NotLocked
CloudColor2 = 0.07,0.17,0.24 NotLocked
SunLightColor = 0.7,0.5,0.3 NotLocked
Cloudvar1 = 0.99 NotLocked
Cloudvar2 = 1 NotLocked
CloudIter = 5 NotLocked
CloudBgMix = 1 NotLocked
MI = 19
ColorIterations = 10
Size = 0.8125915
CSize = 0.8841083,1.311589,0.7800139
C = 0.1291209,-1.667582,-1.324176
TThickness = 0.01
DEoffset = 6.7e-05
Offset = 0.0558659,-0.2555866,-0.622905
#endpreset



